Can someone show me how to change the API call to reflect a more generic macro? What I need is a simple macro to select chain ref. sketch geom. under the mouse and convert it entities. when I run the macro recorder I get: Dim swApp As Object Dim Part As Object Dim boolstatus As Boolean Dim longstatus As Long, longwarnings As Long Dim FeatureData As Object Dim Feature As Object Dim Component As Object Sub main() Set swApp = Application.SldWorks Set Part = swApp.ActiveDoc boolstatus = Part.Extension.SelectByID2("Line31@Sketch7", "EXTSKETCHSEGMENT", 0.02657237821555, -0.04846803192663, 0, False, 0, Nothing) boolstatus = Part.SketchUseEdge2(False) Part.ClearSelection2 True End Sub Not sure how to clean this up and just work with what under the mouse. Any help would be great. Eric